#include "Timer.hpp"
using namespace mpc;

#include <stdio.h>
#include <iostream>
using namespace std;

#include <stdlib.h>
#include <cstdlib>

int main()
{
  Timer timer;

  char c;
  bool fin = false;

  while(!fin)
    {
      if(scanf("%c",&c) == 0)
	{
	  cout << "Bad input value" << endl;
	}
      else
	{
	  switch(c)
	    {
	    case 's' : 
	      {
		timer.start();
		cout << "Timer started" << endl;
		break;
	      }

	    case 'd' : 
	      {
		timer.stop();
		cout << "Timer stopped" << endl;
		break;
	      }

	    case 'q' : 
	      {
		fin = true;
		break;
	      }

	    case 'r' : 
	      {
		int res = timer.reinit();
		if(res == 0) cout << "Timer reinitialized" << endl;
		else cout << "The timer cannot be reinitialized. Stop it first." << endl;
		break;
	      }

	    case 'e' : 
	      {
		double timePast = timer.elapsedTime();
		cout << "Elapsed time : " << timePast;
		cout << "   Avg time period : " << timer.avgPeriod();
		cout << "   Avg time frequency : " << timer.avgFrequency() << endl;
		break;
	      }
		
	    case 't' : 
	      {
		double timePast = timer.totalElapsedTime();
		cout << "Total elapsed time : " << timePast << endl;
		break;
	      }
	    case 'h' : 
	      {
		cout << "s -> Start the timer" << endl;
		cout << "d -> Stop the timer" << endl;
		cout << "q -> Quit" << endl;
		cout << "r -> Reinit the timer" << endl;
		cout << "e -> Ask for the elapsed time from the last request" << endl;
		cout << "t -> Ask for the total elapsed time" << endl;
		cout << "h -> Display this help" << endl;
		break;
	      }
	    default : 
	      {
		cout << "Unknown input. Type 'h' for help" << endl;
		break;
	      }
	    }
	}
    }

  cout << "End timer" << endl;
  return 0;
}
