#include "ControlPoint.hpp"
using namespace mpc;

/********** Constructors and destructors **********/

/**
 *  \brief default constructor
 */
ControlPoint2D::ControlPoint2D() : PositionXY()
{
//   this->x() = 0;
//   this->y() = 0;
}

/**
 *  \brief copy constructor
 *  \param c : the control point to copy
 */
ControlPoint2D::ControlPoint2D(const ControlPoint2D& c) : PositionXY(c)
{
//   this->x() = c.x();
//   this->y() = c.y();
}

/**
 *  \brief init constructor
 *  \param x : x coord of the control point
 *  \param y : y coord of the control point
 */
ControlPoint2D::ControlPoint2D(double x,double y) : PositionXY(x,y)
{
//   this->x() = x;
//   this->y() = y;
}

/**
 *  \brief destructor
 */
ControlPoint2D::~ControlPoint2D()
{
}


                                    /**************************************************/
                                    /*************** Class ControlPoint ***************/
                                    /**************************************************/

/********** Constructors and destructors **********/

/**
 *  \brief default constructor
 */
ControlPoint3D::ControlPoint3D() : PositionXYZ()
{
//   this->z_ = 0;
}

/**
 *  \brief copy constructor
 *  \param c : the control point to copy
 */
ControlPoint3D::ControlPoint3D(const ControlPoint3D& c) : PositionXYZ(c)
{
//   this->z_ = c.z_;
}

/**
 *  \brief init constructor
 *  \param x : x coord of the control point
 *  \param y : y coord of the control point
 *  \param z : z coord of the control point
 */
ControlPoint3D::ControlPoint3D(double x,double y,double z) : PositionXYZ(x,y,z)
{
//   this->z_ = z;
}

/**
 *  \brief destructor
 */
ControlPoint3D::~ControlPoint3D()
{
}
