#include "MapHugr.hpp"
#include "hugr.hpp"
#include "iplimage-serializer.hpp"

using namespace std;
using namespace mpc;
using namespace hugr;


/************* Constructors and destructors ************/

// default constructor
MapHugr::MapHugr() : Map()
{
}

// copy constructor
MapHugr::MapHugr(const MapHugr& m) : Map(m)
{
}

// init constructor
MapHugr::MapHugr(const int wt,const int ht) : Map(wt,ht)
{
}

// destructor
MapHugr::~MapHugr()
{
}

/************ Map loading/saving functions *************/

// Reading function for iplImage type map
int MapHugr::load(const char* nomfic)
{
  cout << "MapHugr::load" << endl;

  	bool comment = false;
	
	Store store;
	VariableId id;
	IplImage *image;
	
// 	char* bufE = new char[1];
// 	int* buf = new int[1];
// 	char* bufCh = new char[20];
// 	int tailleBufCh = 0;
// 	long int nbPts = 0;
// 	bool estSeuillee = true;
	
	store.connect();
		
	id = store.lookupVariable(nomfic);
	
	image = cvCreateImage(cvSize(10,10), IPL_DEPTH_8U, 1);
	store.readVariable(id, *image, false);
	
       	w = image->width;
	h = image->height;
	typ = PGM;
	d = 255; 
	  
	initTabC(w, h);
	
	char* data;
	int step;
	
	CvSize size;
	int x, y;
	
	cvGetRawData( image, (uchar**)&data, &step, &size );
	step /= sizeof(data[0]);
	
	for( y = 0; y < size.height; y++, data += step )
	  for( x = 0; x < size.width; x++ )
            //tabC[y][x] = this->d - (this->d * ((double) data[x]));
	    this->setCol(y,x, this->d - (this->d * ((double) data[x])));
	
	cout << "End of reading." << endl;

	return 0;
}
