#ifndef MPC_STRUCTS_GEN_H
#define MPC_STRUCTS_GEN_H

#include "genPosStruct.h"


/***********************************************************************/
/* Robotic system type */

#define MPC_UNDEFINED_SYS 0
#define MPC_MANA_SYS 1

#define ROBOTIC_SYS_T int


/* /\***********************************************************************\/ */
/* /\* 2D path tab max size *\/ */
/* #define PL_PLAN_MAXSIZE 250 */
/* #define PL_DISP_PLAN_MAXSIZE 15 */

/* /\* Struct containing a 2D path *\/ */
/* typedef struct PL_PATH_XY */
/* { */
/*   GENPOS_CART_CONFIG tab[PL_PLAN_MAXSIZE]; */
/*   int nbPos; */
/* } PL_PATH_XY; */


/***********************************************************************/
/****************************** Unused ? *******************************/
/***********************************************************************/

/***********************************************************************/
/* Struct containing a Mana pose */
typedef struct MANA_POSE {
  double x;
  double y;
  double z;
  double yaw;
  double pitch;
  double roll;

} MANA_POSE;


/***********************************************************************/
/* Struct containing a Mana control */
typedef struct MANA_CTRL {
  double v;
  double w;
} MANA_CTRL;


/***********************************************************************/
/* Struct containing Mana system constraints */
typedef struct MANA_SYS_CSTT {
  double length;                /* length of the Mana base */
  double width;                 /* length of the Mana base */
  double vMax;                  /* maximal speed */
  double wMax;                  /* maximal angular speed */
  double aMax;                  /* maximal acceleration */
  double uMax;                  /* maximal angular acceleration */
} MANA_SYS_CSTT;


#endif // MPC_STRUCTS_GEN_H
