#ifndef MPC_RGBCOLOR_HPP
#define MPC_RGBCOLOR_HPP

namespace mpc
{
                                    /**************************************************/
                                    /***************** Class RGBColor *****************/
                                    /**************************************************/

  /** \class RGBColor
   *  \brief RGB color
   */
  class RGBColor
  {
  protected : 
    int r_;                                                    /**< red value */
    int g_;                                                    /**< green value */
    int b_;                                                    /**< blue value */
    int d_;                                                    /**< color depth */

    /********** Constructors and destructors **********/

//   protected : 
  public : 
    /**
     *  \brief default constructor
     */  
    RGBColor(int d=255);

  public : 
    /**
     *  \brief init constructor
     */  
    RGBColor(int r, int g, int b, int d=255);

    /**
     *  \brief destructor
     */  
    ~RGBColor();

    /******************** Accessors *******************/

    /**
     *  \brief accessor to the red color
     *  \return a reference to the red color
     */
    inline int& r() { return this->r_; }

    /**
     *  \brief accessor to the red color
     *  \return the red color
     */
    inline int r() const { return this->r_; }

    /**
     *  \brief accessor to the green color
     *  \return a reference to the green color
     */
    inline int& g() { return this->g_; }

    /**
     *  \brief accessor to the green color
     *  \return the green color
     */
    inline int g() const { return this->g_; }

    /**
     *  \brief accessor to the blue color
     *  \return a reference to the blue color
     */
    inline int& b() { return this->b_; }

    /**
     *  \brief accessor to the blue color
     *  \return the blue color
     */
    inline int b() const { return this->b_; }

    /**
     *  \brief accessor to the color depth
     *  \return the color depth
     */
    inline int d() const { return this->d_; }
  };
};

#endif // MPC_RGBCOLOR_HPP
