//#include "quadrature.h"  //Numerical integration of 1 variable function
#include "nrtypes.h"     //Definition of matrix and vector
#include "nr.h"
#include "nrutil.h"
//#include "matrix.h"      //Matrix operations

#include <cmath>

#include <iostream>
using namespace std;

using namespace NR;

int main()
{
  const int N=4;

  Mat_DP a(N,N), a2(N,N), y(N,N), prod(N,N);
  Vec_DP col(N);
  Vec_INT indx(N);
  double d;
  int i,j,k;
  a[0][0] = 1; a[0][1] = 2; a[0][2] = 3; a[0][3] = 4;
  a[1][0] = 2; a[1][1] = 3; a[1][2] = 1; a[1][3] = 4;
  a[2][0] = 5; a[2][1] = 2; a[2][2] = 0; a[2][3] = 6;
  a[3][0] = 3; a[3][1] = 7; a[3][2] = 1; a[3][3] = 1;
  
  for(i=0; i<N; i++)
    {
      for(j=0; j<N; j++)
	{
	  a2[i][j] = a[i][j];
	}
    }

  cout << "Matrice A : " << endl; 
  for(i=0; i<N; i++)
    {
      for(j=0; j<N; j++)
	cout << a2[i][j] << " ";
      cout << endl;
    }

  ludcmp(a,indx,d);
  for(j=0; j<N; j++)
    {
      for(i=0; i<N; i++) col[i] = 0.0;
      col[j] = 1.0;
      lubksb(a,indx,col);
      for(i=0; i<N; i++) y[i][j] = col[i];
    }

  cout << "Matrice Y : " << endl;
  for(j=0; j<N; j++)
    {
      for(i=0; i<N; i++)
	cout << y[i][j] << " ";
      cout << endl;
    }

  for(i=0; i<N; i++)
    {
      for(j=0; j<N; j++)
	{
	  double sum=0;
	  for(k=0; k<N; k++)
	    {
	      sum += (a2[i][k] * y[k][j]);
	    }
	  prod[i][j] = sum;
	}
    }

  cout << "Matrice Prod : " << endl;
  for(j=0; j<N; j++)
    {
      for(i=0; i<N; i++)
	cout << prod[i][j] << " ";
      cout << endl;
    }

  return 0;
}
