#include "math/inc/Operation.hpp"
using namespace mpc;

                                    /**************************************************/
                                    /***************** Class Operation ****************/
                                    /**************************************************/

/********** Constructors and destructors **********/

/**
 *  \brief default constructor
 */
Operation::Operation()
{
  this->nbOperand_ = 0;
  this->op_ = ND_OP;
  this->tabOperand_ = NULL;

  this->type_ = ND_FUNC;
}

/**
 *  \brief init constructor (from the mumber of operands)
 *  \param nbOp : the number of operands
 */
Operation::Operation(int nbOp)
{
  this->nbOperand_ = nbOp;
  this->op_ = ND_OP;
  this->tabOperand_ = new Function* [nbOperand_];
  for(int i=0; i<nbOperand_; i++)
    {
      this->tabOperand_[i] = NULL;
    }
}

/**
 *  \brief default constructor
 */
Operation::Operation(const Operation& op)
{
  this->nbOperand_ = op.nbOperand_;
  this->op_ = op.op_;

  if(op.tabOperand_ != NULL)
    {
      this->tabOperand_ = new Function* [nbOperand_];
      for(int i=0; i<nbOperand_; i++)
	{
	  this->tabOperand_[i] = op.tabOperand_[i]->copy();
	}
    }
  else this->tabOperand_ = NULL;

  this->setBounds(op.getBInf(),op.getBSup());

  this->type_ = op.type_;
}

/**
 *  \brief destructor
 */
Operation::~Operation()
{
  if(tabOperand_ != NULL)
    {
      for(int i=0; i<nbOperand_; i++)
	{
	  if(tabOperand_[i] != NULL) delete tabOperand_[i];
	}
      delete [] tabOperand_;
    }
}
