#include "motion/inc/Shift.hpp"
using namespace mpc;

                                    /**************************************************/
                                    /******************* Class Shift ******************/
                                    /**************************************************/

/********** Constructors and destructors **********/

/**
 *  \brief default constructor
 */
Shift::Shift() : Vector()
{
}

/**
 *  \brief copy constructor
 *  \param p : the control to copy
 */
Shift::Shift(const Shift& s) : Vector(s)
{
}

/**
 *  \brief destructor
 */
Shift::~Shift()
{
}

/**
 *  \brief init constructor
 *  \param n : dimension of the state
 */
Shift::Shift(int n) : Vector(n)
{
}


                                    /**************************************************/
                                    /***************** Class YThShift *****************/
                                    /**************************************************/

/********** Constructors and destructors **********/

/**
 *  \brief default constructor
 */
YThShift::YThShift() : Shift(2)
{
}

/**
 *  \brief copy constructor
 *  \param p : the control to copy
 */
YThShift::YThShift(const YThShift& s) : Shift(s)
{
}

/**
 *  \brief init constructor
 *  \param y : the lateral shift
 *  \param th : the angular shift
 */
YThShift::YThShift(double y, double th) : Shift(2)
{
  this->y() = y;
  this->th() = th;
}

/**
 *  \brief destructor
 */
YThShift::~YThShift()
{
}

/**
 *  \brief init constructor
 *  \param n : dimension of the state
 */
YThShift::YThShift(int n) : Shift(n)
{
}


                                    /**************************************************/
                                    /***************** Class YThSShift ****************/
                                    /**************************************************/

/********** Constructors and destructors **********/

/**
 *  \brief default constructor
 */
YThSShift::YThSShift() : YThShift(3)
{
}

/**
 *  \brief copy constructor
 *  \param p : the control to copy
 */
YThSShift::YThSShift(const YThSShift& s) : YThShift(s)
{
}

/**
 *  \brief init constructor
 *  \param y : the lateral shift
 *  \param th : the angular shift
 *  \param s : the curve abscica
 */
YThSShift::YThSShift(double y, double th, double s) : YThShift(3)
{
  this->y() = y;
  this->th() = th;
  this->s() = s;
}

/**
 *  \brief destructor
 */
YThSShift::~YThSShift()
{
}
