#include "PathPlanner.hpp"
using namespace mpc;

                                    /**************************************************/
                                    /**************** Class PathPlanner ***************/
                                    /**************************************************/

/************* Constructors and destructors ************/

/**
 *  \brief default constructor
 */
PathPlanner::PathPlanner()
{
  this->path_ = NULL;
  this->env_ = NULL;
  this->initCfg_ = NULL;
  this->goalCfg_ = NULL;
  this->status_ = PP_NOT_STARTED;
}

/**
 *  \brief init constructor
 *  \param sys : robotic system handled
 *  \param e : environment in which the system evolve
 */
PathPlanner::PathPlanner(System* sys,Environment* e)
{
  this->path_ = NULL;
  this->env_ = e;
  this->sys_ = sys;
  this->initCfg_ = NULL;
  this->goalCfg_ = NULL;
  this->status_ = PP_NOT_STARTED;
}

// /**
//  *  \brief init constructor
//  *  \param sys : robotic system handled
//  *  \param m : map of the environment in which the system evolve
//  */
// PathPlanner::PathPlanner(System* sys,Map* m)
// {
//   this->path_ = NULL;
//   this->env_ = new Environment(m);
//   this->sys_ = sys;
//   this->initCfg_ = NULL;
//   this->goalCfg_ = NULL;
//   this->status_ = PP_NOT_STARTED;
// }

/**
 *  \brief destructor
 */
PathPlanner::~PathPlanner()
{
  if(initCfg_ != NULL) delete initCfg_;
  if(goalCfg_ != NULL) delete goalCfg_;
  if(path_ != NULL) delete path_;
}





// /************* Constructors and destructors ************/

// // default constructor
// PathPlanner::PathPlanner()
// {
//   //this->path     = new Path;
//   this->path     = NULL;
//   //this->map      = NULL;
//   this->env_     = NULL;
//   this->initCfg  = NULL;
//   this->goalCfg  = NULL;
// }

// // // copy constructor
// // PathPlanner::PathPlanner(const PathPlanner& pp)
// // {
// //   //this->path    = pp.path;
// //   //this->map     = pp.map;
// //   this->env_    = pp.env_;
// //   this->initCfg = pp.initCfg;
// //   this->goalCfg = pp.goalCfg;
// // }

// // init constructor
// PathPlanner::PathPlanner(Environment* e, ConfigR* cfg1, ConfigR* cfg2)
// {
//   //this->path    = new Path;
//   this->env_    = e;
//   this->initCfg = cfg1;
//   this->goalCfg = cfg2;
// }

// // destructor
// PathPlanner::~PathPlanner()
// {
//   if(this->path != NULL) delete path;
//   //  if(this->initCfg != NULL) delete initCfg;
//   //  if(this->goalCfg != NULL) delete goalCfg;
// }
        

// /********************** Accessors **********************/

// // return the current path
// Path* PathPlanner::getPath() const
// {
//     return this->path;
// }

// // return the current map
// Map* PathPlanner::getMap() const
// {
// //   if(this->env_ != NULL)
// //     return this->env_->getMap();
//   return this->map;
// }

// // set the current map
// void PathPlanner::setMap(Map* m)
// {
// //   if(this->env_ != NULL)
// //     this->env_->setMap(m);
//   this->map = m;
// }

// // return the current environment
// Environment* PathPlanner::getEnv() const
// {
//     return this->env_;
// }

// // set the current environment
// void PathPlanner::setEnv(Environment* e)
// {
//     this->env_ = e;
// }

// // return the initial configuration
// ConfigR* PathPlanner::getInitCfg() const
// {
//     return this->initCfg;
// }

// // set the initial configuration
// void PathPlanner::setInitCfg(ConfigR* c)
// {
//   if(this->initCfg != NULL) delete initCfg;
//   this->initCfg = c;
// }

// // return the goal configuration
// ConfigR* PathPlanner::getGoalCfg() const
// {
//     return this->goalCfg;
// }

// // set the goal configuration
// void PathPlanner::setGoalCfg(ConfigR* c)
// {
//   if(this->goalCfg != NULL) delete goalCfg;
//   this->goalCfg = c;
// }


