#include "SpaceShipSys.hpp"
using namespace mpc;

#include <cmath>
#include <stdlib.h>
#include <iostream>
using namespace std;

                                    /**************************************************/
                                    /*************** Class SpaceShipSys ***************/
                                    /**************************************************/

/********** Constructors and destructors **********/

/**
 *  \brief default constructor
 */
SpaceShipSys::SpaceShipSys()
{
  this->radius_ = 0;
  this->vxMax_  = 0;
  this->vyMax_  = 0;
  this->vthMax_ = 0;
  this->axMax_  = 0;
  this->ayMax_  = 0;
  this->athMax_ = 0;
  this->type_   = SPACESHIP_SYS;
}

/**
 *  \brief destructor
 */
SpaceShipSys::~SpaceShipSys()
{
}


/************** Getters and setters ***************/

/**
 *  \brief getter : return the maximal linear velocity
 *  \return maximal linear velocity
 */
double SpaceShipSys::getVMax() const 
{ 
  return sqrt(vxMax_*vxMax_ + vyMax_*vyMax_); 
}

/**
 *  \brief getter : return the maximal linear acceleration
 *  \return maximal linear acceleration
 */
double SpaceShipSys::getAMax() const 
{ 
  return sqrt(axMax_*axMax_ + ayMax_*ayMax_);
}


/*************** Display functions ****************/

/**
 *  \brief display the features of the car-like system
 */
void SpaceShipSys::display() const
{
  cout << "Space Ship System : " << endl;
  cout << "\t X Speed Max : " << vxMax_ << endl;
  cout << "\t Y Speed Max : " << vyMax_ << endl;
  cout << "\t TH Speed Max : " << vthMax_ << endl;
  cout << "\t X Acc Max : " << axMax_ << endl;
  cout << "\t Y Acc Max : " << ayMax_ << endl;
  cout << "\t TH Acc Max : " << athMax_ << endl;
  cout<< endl;
}

/**
 *  \brief draw the car-like system in an openGL viewer
 */
void SpaceShipSys::toGL() const
{
}

/**
 *  \brief convert the system into a string
 *  \return the resulting string
 */
const char* SpaceShipSys::toString() const
{
  cerr << "SpaceShipSys::toString : Not implemented yet!" << endl;
  exit(1);
}
