namespace eval config {
	variable robot dala_simu
}

source ../config/$config::robot/$config::robot.tcl

# here you can override settings from $config::robot.tcl
# If it must be a permanent changes, you can modify $config::robot.tcl and
# commit it
namespace eval config {

	# A list of machines 
	variable machines { localhost }
	# Module list
	# The order IS important, it will be the lauch order (to start and init it)
	namespace eval localhost {
		variable modules { pom simu_loco stereopixel dtm MPC_controller MPC_planner MPC_avoidObs }
	}

	## It is the list of "permanent" modules, aka module which have a systematic activity
	# For this modules, we will call automaticly ${module}TaskRun (in the order)
	variable perm_modules { pom }

	## The list of modules you want to log automaticly (on a call of TaskLog)
	variable log_modules {  }

	## The directory where you want to store the log
	# It is better if it is an absolute path, however, it will be built using root
	# the tcl-script directory
	variable log_dir /home/vdelsart/log

	## The machine where the module runs
	variable host localhost

	# Are we in normal mode (0) or Simu mode (1)
	variable simu true

	namespace eval gdhe {
		# Gdhe environnement (for remote display)
		variable server localhost

		# Export some output over Gdhe
		variable output false
	}

	namespace eval viam {
		variable use_morse true
		variable use_marlin false
		variable use_flea false
		variable use_flea2 false
		variable use_pano false
	}


	# Set 1 if the module is available (started) AND should be used (by other modules)
	variable use_mti false
	variable use_gyro true
	variable use_gps false
	variable use_platine false

	namespace eval p3d {
		variable debug false
		variable debug_home ""
	}

	namespace eval regionMap {
	    namespace eval init {
		variable scale 0.5
		variable sizeX 500
		variable sizeY 500
		# Adapted for loading Ressac's maps
		# Ressac : ONERA Autonomous Helicopter
		variable xOrigin -125
		variable yOrigin -99.5
		# The robot radius should be overidden in the robot configuration
		variable robotRadius 1
		variable fusionType "RMAP_OVERRIDE"
		variable protosFileName "/home/rboumgha/openrobots-devel/data/protoSpace.psp"
	    }

	    namespace eval connect {
		variable active false
		variable module "stereopixel"
		variable stereo_poster "stereopixelThreeDImage"
		variable velodyne_poster "velodyneThreeDImage"
	    }
	}

	namespace eval rednav {
		variable regionMapPoster "regionMapRmap"
		variable pomPosPoster "pomPos"
		variable logDir "/tmp"
	}

	namespace eval rviewer {
			variable tracking_speed 100
			variable defaultUpdateSpeed 500
			variable updateSpeed
			set updateSpeed(rmp400) 500
			set updateSpeed(pom) 500
			set updateSpeed(viam) 800
			set updateSpeed(dtm) 900
	}

}
